package com.cuit.solarenergy.base;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 分页查询基础类
 * @author ZengwuWang
 */
@ApiModel(description = "分页查询条件")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class BasePageQuery {
    /**
     * 当前页数索引（当前页码）
     */
    @ApiModelProperty(value = "当前页数（缺省为1）", name = "current", required = false, example = "1")
    private Integer current = 1;
    /**
     * 当前页数限定数据条数
     */
    @ApiModelProperty(value = "每一页数据条数（-1时不分页）", name = "size", required = false, example = "10")
    private Integer size = 10;
}
