package com.cuit.solarenergy.base.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * @author wzw
 * @description 定义Aop切点
 * @date 2022/0924
 */

@Target({ElementType.METHOD, ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
public @interface AopLog {
    //模块id
    String module() default "";
    //操作名
    String operation() default "";
    //系统类型 0-web端  1-app
    int sysType() default 1;

    //操作类型 操作类型  0-增 1-删 2-改 3-查 4-审核 5-登录 6-数据导入 7-数据导出 8-数据下载
    int opType() default 5;
}
