package com.cuit.solarenergy.common.aop;//package com.cuit.railway.common.aop;
//
//
//import com.cuit.solarenergy.base.annotation.AopLog;
//import com.cuit.solarenergy.entity.sys.SysLog;
//import com.cuit.solarenergy.mapper.SysLogMapper;
//import com.cuit.solarenergy.utils.RedisUtil;
//import com.cuit.solarenergy.utils.RequestUtil;
//import org.aspectj.lang.JoinPoint;
//import org.aspectj.lang.ProceedingJoinPoint;
//import org.aspectj.lang.annotation.After;
//import org.aspectj.lang.annotation.Aspect;
//import org.aspectj.lang.annotation.Before;
//import org.aspectj.lang.annotation.Pointcut;
//import org.aspectj.lang.reflect.CodeSignature;
//import org.aspectj.lang.reflect.MethodSignature;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.stereotype.Component;
//import org.springframework.web.context.request.RequestAttributes;
//import org.springframework.web.context.request.RequestContextHolder;
//import org.springframework.web.context.request.ServletRequestAttributes;
//
//import javax.annotation.Resource;
//import javax.servlet.http.HttpServletRequest;
//import java.lang.reflect.Method;
//import java.time.Duration;
//import java.time.LocalDateTime;
//import java.util.HashMap;
//import java.util.Map;
//
///**
// * @author wzw
// * @dexcription aop 记录日志切面类
// */
//@Aspect
//@Component
//public class AopLogAspect {
//
//    @Autowired
//    private SysLogMapper logMapper;
//    @Resource
//    private RedisUtil redisUtils;
//
//    /**
//     * 请求地址
//     */
//    private String requestPath = null;
//    /**
//     * 访问时间
//     */
//    private LocalDateTime startTimeMillis = null;
//    /**
//     * 结束时间
//     */
//    private long endTimeMillis = 0;
//    /**
//     * 操作人
//     */
//    private String account = null;
//    /**
//     * 请求
//     */
//    private HttpServletRequest request = null;
//    /**
//     * 操作人
//     */
//    private Integer sysType = null;
//
//
//    /**
//     * 注解的位置
//     */
//    @Pointcut("@annotation(com.cuit.railway.base.annotation.AopLog)")
//    public void logPointCut() {
//    }
//
//    /**
//     * @param joinPoint
//     * @Description 前置通知  方法调用前触发   记录开始时间,从请求中获取用户名
//     */
//    @Before(value = "logPointCut()")
//    public void before(JoinPoint joinPoint) {
//        //获取接口访问时间
//        startTimeMillis = LocalDateTime.now();
//        //获取当前用户名
//        account = (String) redisUtils.get(RequestUtil.releaseTokenFromRequest(getHttpServletRequest()));
//    }
//
//    /**
//     * @param joinPoint
//     * @return
//     * @Description 获取入参方法参数
//     */
//    public Map<String, Object> getNameAndValue(JoinPoint joinPoint) {
//        Map<String, Object> param = new HashMap<>();
//        Object[] paramValues = joinPoint.getArgs();
//        String[] paramNames = ((CodeSignature) joinPoint.getSignature()).getParameterNames();
//        for (int i = 0; i < paramNames.length; i++) {
//            if (paramValues[i] instanceof Integer || paramValues[i] instanceof String) {
//                param.put(paramNames[i], paramValues[i]);
//            }
//        }
//        return param;
//    }
//
//
//    /**
//     * @param joinPoint
//     * @Description 后置通知    方法调用后触发   记录结束时间 ,操作人 ,入参等
//     */
//    @After(value = "logPointCut()")
//    public void after(JoinPoint joinPoint) {
//        request = getHttpServletRequest();
//        // 获取类名
//        String targetName = joinPoint.getTarget().getClass().getName();
//        // 获取方法签名
//        MethodSignature methodSignature = (MethodSignature) joinPoint.getSignature();
//        // 获取方法上的注解
//        Method method = methodSignature.getMethod();
//        // 获取方法上面的AopLog、RequestMapping注解
//        AopLog aopLog = method.getAnnotation(AopLog.class);
////        RequestMapping requestMapping = method.getAnnotation(RequestMapping.class);
//        //构建日志对象并存入数据库
//        logMapper.insert(SysLog.builder().isValid(1)
//                .module(aopLog.module())
//                .opration(aopLog.operation())
//                .visitTime(startTimeMillis)
//                .opType(aopLog.opType())
//                .sysType(aopLog.sysType())
//                .method(joinPoint.getSignature().getName())
//                .ip(getIpAddress())
//                .executionTime(Duration.between(startTimeMillis,LocalDateTime.now()).toMillis() + "毫秒")
//                .userName(account)
//                .build());
//    }
//
//    /**
//     * 获取ip地址
//     *
//     * @return
//     */
//    public String getIpAddress() {
//        HttpServletRequest request = getHttpServletRequest();
//        String ip = request.getHeader("x-forwarded-for");
//        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
//            ip = request.getHeader("Proxy-Client-IP");
//        }
//        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
//            ip = request.getHeader("WL-Proxy-Client-IP");
//        }
//        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
//            ip = request.getHeader("HTTP_CLIENT_IP");
//        }
//        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
//            ip = request.getHeader("HTTP_X_FORWARDED_FOR");
//        }
//        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
//            ip = request.getRemoteAddr();
//        }
//        return ip;
//    }
//
//
//    /**
//     * @Description: 获取request
//     */
//    public HttpServletRequest getHttpServletRequest() {
//        RequestAttributes ra = RequestContextHolder.getRequestAttributes();
//        ServletRequestAttributes sra = (ServletRequestAttributes) ra;
//        HttpServletRequest request = sra.getRequest();
//        return request;
//    }
//
//
//    /**
//     * @param joinPoint
//     * @return 环绕通知
//     * @throws Throwable
//     */
//    public Object around(ProceedingJoinPoint joinPoint) throws Throwable {
//        return null;
//    }
//
//    /**
//     * @param joinPoint
//     * @Description 异常通知
//     */
//    public void throwing(JoinPoint joinPoint) {
//        System.out.println("异常通知");
//    }
//
//
//}
