package com.cuit.solarenergy.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpHeaders;
import org.springframework.web.servlet.config.annotation.CorsRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class WebConfig implements WebMvcConfigurer {
//    @Autowired
//    FireModelConfig fireModelConfig;
//    @Override
//    public void addResourceHandlers(ResourceHandlerRegistry registry) {
//        /**
//         * @Description: 对文件的路径进行配置,创建一个虚拟路径/file/**
//         *这是图片的物理路径 "file:/+本地图片的地址"
//         */
//        String url = "D:/smweb/";
//        url = fireModelConfig.getSourcedir();
//        registry.addResourceHandler("/file/**").addResourceLocations("file:"+url);
//    }
    /**
     * 设置允许跨域请求
     * @return
     */
    @Bean
    public WebMvcConfigurer corsConfigurer() {

        return new WebMvcConfigurer() {
            @Override
            public void addCorsMappings(CorsRegistry registry) {
                registry
                        .addMapping("/**")
                        //.allowedOrigins("http://yyy.com", "http://xxx.com") //
                        // 允许跨域的域名
                        .allowedOriginPatterns("*") // 允许所有域
                        .allowedMethods("*")        // 允许任何方法（post、get等）
                        .allowedHeaders("*")        // 允许任何请求头
                        .allowCredentials(true)     // 允许证书、cookie
                        .exposedHeaders(HttpHeaders.SET_COOKIE)
                        .maxAge(3600L);            // maxAge(3600)表明在3600秒内，不需要再发送预检验请求，可以缓存该结果
            }
        };
    }

//    @Override
//    public void addInterceptors(InterceptorRegistry registry) {
//        registry.addInterceptor(new AuthorizationInterceptor()).addPathPatterns("/**");
//    }
}
