package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 
 * @TableName t_geoserverinfo_base
 */
@TableName(value ="t_geoserverinfo_base")
@Data
public class GeoserverinfoBase implements Serializable {
    /**
     * 序列号
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * GeoServer服务工作区（访问地址）
     */
    private String geoserverworkspaces;

    /**
     * GeoServer服务图层名
     */
    private String geoserverlayers;

    /**
     * GeoServer服务样式名
     */
    private String geoserverstyles;

    /**
     * 坐标
     */
    private String srs;

    /**
     * 边框
     */
    private String bbox;

    /**
     * 经纬度边框
     */
    private String latlonbbox;

    /**
     * 地址（自动生成）
     */
    private String url;

    /**
     * 数据生成时间（自动生成）
     */
    private Date createdate;

    /**
     * 流域代码
     */
    private String streamCode;

    /**
     * 数据代码
     */
    private String datacode;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        GeoserverinfoBase other = (GeoserverinfoBase) that;
        return (this.getId() == null ? other.getId() == null : this.getId().equals(other.getId()))
            && (this.getGeoserverworkspaces() == null ? other.getGeoserverworkspaces() == null : this.getGeoserverworkspaces().equals(other.getGeoserverworkspaces()))
            && (this.getGeoserverlayers() == null ? other.getGeoserverlayers() == null : this.getGeoserverlayers().equals(other.getGeoserverlayers()))
            && (this.getGeoserverstyles() == null ? other.getGeoserverstyles() == null : this.getGeoserverstyles().equals(other.getGeoserverstyles()))
            && (this.getSrs() == null ? other.getSrs() == null : this.getSrs().equals(other.getSrs()))
            && (this.getBbox() == null ? other.getBbox() == null : this.getBbox().equals(other.getBbox()))
            && (this.getLatlonbbox() == null ? other.getLatlonbbox() == null : this.getLatlonbbox().equals(other.getLatlonbbox()))
            && (this.getUrl() == null ? other.getUrl() == null : this.getUrl().equals(other.getUrl()))
            && (this.getCreatedate() == null ? other.getCreatedate() == null : this.getCreatedate().equals(other.getCreatedate()))
            && (this.getStreamCode() == null ? other.getStreamCode() == null : this.getStreamCode().equals(other.getStreamCode()))
            && (this.getDatacode() == null ? other.getDatacode() == null : this.getDatacode().equals(other.getDatacode()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getId() == null) ? 0 : getId().hashCode());
        result = prime * result + ((getGeoserverworkspaces() == null) ? 0 : getGeoserverworkspaces().hashCode());
        result = prime * result + ((getGeoserverlayers() == null) ? 0 : getGeoserverlayers().hashCode());
        result = prime * result + ((getGeoserverstyles() == null) ? 0 : getGeoserverstyles().hashCode());
        result = prime * result + ((getSrs() == null) ? 0 : getSrs().hashCode());
        result = prime * result + ((getBbox() == null) ? 0 : getBbox().hashCode());
        result = prime * result + ((getLatlonbbox() == null) ? 0 : getLatlonbbox().hashCode());
        result = prime * result + ((getUrl() == null) ? 0 : getUrl().hashCode());
        result = prime * result + ((getCreatedate() == null) ? 0 : getCreatedate().hashCode());
        result = prime * result + ((getStreamCode() == null) ? 0 : getStreamCode().hashCode());
        result = prime * result + ((getDatacode() == null) ? 0 : getDatacode().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", geoserverworkspaces=").append(geoserverworkspaces);
        sb.append(", geoserverlayers=").append(geoserverlayers);
        sb.append(", geoserverstyles=").append(geoserverstyles);
        sb.append(", srs=").append(srs);
        sb.append(", bbox=").append(bbox);
        sb.append(", latlonbbox=").append(latlonbbox);
        sb.append(", url=").append(url);
        sb.append(", createdate=").append(createdate);
        sb.append(", streamCode=").append(streamCode);
        sb.append(", datacode=").append(datacode);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}