package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 地图服务表
 * @TableName t_map_service
 */
@TableName(value ="t_map_service")
@Data
public class MapService implements Serializable {
    /**
     * 主键id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Object id;

    /**
     * 无人机缩略图
     */
    @TableField(value = "uav_minus")
    private String uavMinus;

    /**
     * 流域名称
     */
    @TableField(value = "stream_name")
    private String streamName;

    /**
     * 采样点
     */
    @TableField(value = "site_id")
    private String siteId;

    /**
     * 数据日期
     */
    @TableField(value = "create_time")
    private Date createTime;

    /**
     * 反演指标
     */
    @TableField(value = "index_name")
    private String indexName;

    /**
     * 最小值
     */
    @TableField(value = "index_min")
    private Double indexMin;

    /**
     * 最大值
     */
    @TableField(value = "index_max")
    private Double indexMax;

    /**
     * 范围（四个边界点的坐标）
     */
    @TableField(value = "range")
    private String range;

    /**
     * 地图服务（URL）
     */
    @TableField(value = "map_service")
    private String mapService;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}