package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

/**
 *
 * @TableName ts_sys_user
 */
@TableName(value ="ts_sys_user")
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "SysUser对象",description = "用户表")
public class SysUser implements Serializable {

    @TableId(value = "id", type = IdType.AUTO)
    @ApiModelProperty("用户id")
    private Integer id;

    @TableField(value = "loginname")
    @ApiModelProperty("登录名")
    private String loginname;

    @TableField(value = "name")
    @ApiModelProperty("姓名")
    private String name;

    @TableField(value = "tel")
    @ApiModelProperty("电话号码")
    private String tel;

    @TableField(value = "password")
    @ApiModelProperty("密码")
    private String password;

    @TableField(value = "flag")
    @ApiModelProperty("标志 0-正常 1-禁用 2-换岗")
    private Integer flag;

    @TableField(value = "passchangdate")
    @ApiModelProperty("最后一次修改密码时间")
    private Date passchangdate;

    @TableField(value = "lastip")
    @ApiModelProperty("常用地址IP")
    private String lastip;

    @TableField(value = "lastlogindate")
    @ApiModelProperty("最后一次登录时间")
    private Date lastlogindate;

    @TableField(value = "logerrnum")
    @ApiModelProperty("密码输入错误次数")
    private Integer logerrnum;

    @TableField(value = "isdelete")
    @ApiModelProperty("是否删除")
    @TableLogic(value = "0",delval = "1")
    private Integer isdelete;

    @TableField(value = "locklogindate")
    @ApiModelProperty("锁定时间")
    private Date locklogindate;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}