package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

/**
 * 字典表
 * @TableName t_dict_data
 */
@TableName(value ="t_dict_data")
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "TDictData对象",description = "字典表")
public class TDictData implements Serializable {

    @ApiModelProperty("id")
    @TableId(type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty("字典标签")
    private String label;

    @ApiModelProperty("相对属性")
    private Double relativeAttribute;

    @ApiModelProperty("字典排序")
    private Integer sort;

    @ApiModelProperty("字典键值")
    private String value;

    @ApiModelProperty("字典类型")
    private String dictType;

    @ApiModelProperty("状态（0正常，1停用）")
    private Integer status;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;

    @TableLogic(value = "0",delval = "1")
    @ApiModelProperty("是否删除（0否，1是）")
    private Integer isDeleted;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;


}