package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Builder;
import lombok.Data;

/**
 * minio表
 * @TableName t_minio
 */
@TableName(value ="t_minio")
@Data
@Builder
public class TMinio{
    /**
     * ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 所属流域
     */
    @TableField(value = "stream")
    private String stream;

    /**
     * 文件类型（AVI：视频；PIC：图片）
     */
    @TableField(value = "file_type")
    private String fileType;

    /**
     * 文件大小
     */
    @TableField(value = "file_size")
    private String fileSize;

    /**
     * 文件URL
     */
    @TableField(value = "file_url")
    @JsonIgnore
    private String fileUrl;

    /**
     * minio标识
     */
    @JsonIgnore
    @TableField(value = "minio_id")
    private String minioId;

    /**
     * 文件缩略图
     */
    @TableField(value = "file_url_min")
    private String fileUrlMin;

    /**
     * 文件名称
     */
    @TableField(value = "file_name")
    private String fileName;

    /**
     * 创建时间
     */
    @TableField(value = "create_time")
    private String createTime;


    /**
     * 删除标识（0有效；1删除）
     */
    @TableLogic(value = "0",delval = "1")
    @TableField(value = "is_deleted")
    @JsonIgnore
    private String isDeleted;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}