package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * 采样数据明细表
 * @TableName t_sampling_data_details
 */
@TableName(value ="t_sampling_data_details")
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "TSamplingDataDetails对象",description = "采样数据明细表")
public class TSamplingDataDetails implements Serializable {

    @ApiModelProperty("id")
    @TableId(type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty("站点编号")
    private String siteId;

    @ApiModelProperty("指标编号")
    private String indexCode;

    @ApiModelProperty("指标值（-1：未检出）")
    private Double indexValue;

    @ApiModelProperty("指标情况（0：正常，1：超标，2：严重超标）")
    private Integer indexLevel;

    @ApiModelProperty("创建时间")
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String createTime;

    @TableLogic(value = "0",delval = "1")
    @ApiModelProperty("是否删除（0：否，1：是）")
    private Integer isDeleted;

    @ApiModelProperty("经度")
    private Double lon;

    @ApiModelProperty("纬度")
    private Double lat;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;


}