package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

/**
 * 无人机正射影像数据表
 * @TableName t_uav_dom_image_data
 */
@TableName(value ="t_uav_dom_image_data")
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "TUavDomImageData信息",description = "无人机正射影像数据表")
public class TUavDomImageData implements Serializable {
    /**
     * id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Object id;

    /**
     * 河流id
     */
    @TableField(value = "stream_id")
    private Integer streamId;

    /**
     * 处理方式
     */
    @TableField(value = "process_type")
    private String processType;

    /**
     * 分辨率
     */
    @TableField(value = "image_ratio")
    private Double imageRatio;

    /**
     * 范围（四个边界点的坐标）
     */
    @TableField(value = "range")
    private String range;

    /**
     * 无人机影像
     */
    @TableField(value = "uav_add")
    private String uavAdd;

    /**
     * 无人机缩略图
     */
    @TableField(value = "uav_minus")
    private String uavMinus;

    /**
     * 地图服务（url）
     */
    @TableField(value = "map_service")
    private String mapService;

    /**
     * 创建时间
     */
    @TableField(value = "create_time")
    private Date createTime;

    /**
     * 更新时间
     */
    @TableField(value = "update_time")
    private Date updateTime;

    /**
     * 是否删除（0：否，1：是）
     */
    @TableLogic(value = "0",delval = "1")
    private Integer isDeleted;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}