package com.cuit.solarenergy.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Builder;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 无人机原始影像表
 * @TableName t_uav_data
 */
@TableName(value ="t_uav_data")
@Data
@Builder
public class UavData implements Serializable {
    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 日期
     */
    private Date registerTime;

    /**
     * 河流
     */
    @TableField(value = "stream_cod")
    private String streamCode;
    @TableField(value = "datacode")
    private String dataCode;
    /**
     * 点位
     */
    private String siteId;

    /**
     * 波段数
     */
    private Integer bandNumber;

    /**
     * 范围（边界点的坐标）
     */
    private String bbox;

    /**
     * 原始文件名
     */
    private String originalFileName;

    /**
     * minio地址
     */
    private String minioId;

    /**
     * 是否删除（0：否，1：是）
     */
    private Integer isDeleted;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}