package com.cuit.solarenergy.entity.vo.req;

import com.cuit.solarenergy.base.BasePageQuery;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * @Author: Tjb
 * @CreateTime: 2023-08-07  09:31
 * @Description: 统计分析图表基本信息返回类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "统计分析图表基本信息返回类")
public class ChartBaseInfoVoReq extends BasePageQuery {

    @ApiModelProperty(value = "采样点list", name = "siteList", notes = "多个用,分隔", example = "JS-00,JS-01", required = true)
    private List<String> siteList;

    @ApiModelProperty(value = "采样点水质参数list", name = "indexList", notes = "多个用,分隔", example = "叶绿素,氟,氨氮")
    private List<String> indexList;

    @ApiModelProperty(value = "统计分析模块无人机参数类", name = "statisticAnalysisUAVVoReq")
    private StatisticAnalysisUAVVoReq statisticAnalysisUAVVoReq;

    @ApiModelProperty(value = "统计分析模块卫星遥感参数类", name = "statisticAnalysisSATVoReq")
    private StatisticAnalysisSATVoReq statisticAnalysisSATVoReq;

    @ApiModelProperty(value = "开始时间", name = "startTime", notes = "格式为yyyy-MM-dd")
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String startTime;

    @ApiModelProperty(value = "结束时间", name = "endTime", notes = "格式为yyyy-MM-dd")
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String endTime;

    @ApiModelProperty(value = "经度", name = "lon", required = true)
    @DateTimeFormat(pattern = DATE_FORMAT)
    private Double lon;

    @ApiModelProperty(value = "纬度", name = "lat", required = true)
    @DateTimeFormat(pattern = DATE_FORMAT)
    private Double lat;


}
