package com.cuit.solarenergy.entity.vo.req;

import com.cuit.solarenergy.base.BasePageQuery;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-06  10:38
 * @Description: 数据管理模块查询接口请求参数类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "数据管理模块查询接口请求参数类")
public class DataManageGetVoReq extends BasePageQuery {
    @ApiModelProperty(value = "河流流域",required = false)
    private List<String> streamNameList;

    @ApiModelProperty(value = "采集点名",required = false)
    private List<String> siteIdList;

    @ApiModelProperty(value = "开始时间",required = false)
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String stTime;

    @ApiModelProperty(value = "结束时间",required = false)
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String endTime;

    @ApiModelProperty(value = "关键词",required = false)
    private String keywords;
}
