package com.cuit.solarenergy.entity.vo.req;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @Author: Tjb
 * @CreateTime: 2023-08-07  09:52
 * @Description: 统计分析模块卫星遥感参数类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "统计分析模块卫星遥感参数类")
public class StatisticAnalysisSATVoReq {

    @ApiModelProperty(value = "卫星", name = "satellite")
    private String satellite;

    @ApiModelProperty(value = "SAT红外波段", name = "satIR")
    private String satIR;

    @ApiModelProperty(value = "SAT近红外波段", name = "satNIR")
    private String satNIR;

    @ApiModelProperty(value = "SAT反演数据list", name = "satIndexList", notes = "多个以,分隔", example = "叶绿素,氨氮")
    private List<String> satIndexList;

}
