package com.cuit.solarenergy.entity.vo.req;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @Author: Tjb
 * @CreateTime: 2023-08-07  09:52
 * @Description: 统计分析模块无人机参数类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "统计分析模块无人机参数类")
public class StatisticAnalysisUAVVoReq {

    @ApiModelProperty(value = "UAV红外波段", name = "uavIR")
    private String uavIR;

    @ApiModelProperty(value = "UAV近红外波段", name = "uavNIR")
    private String uavNIR;

    @ApiModelProperty(value = "UAV反演数据list", name = "uavIndexList", notes = "多个以,分隔", example = "叶绿素,氨氮")
    private List<String> uavIndexList;

}
