package com.cuit.solarenergy.entity.vo.req;

import com.cuit.solarenergy.base.BasePageQuery;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-04  10:57
 * @Description: 无人机检测模块请求类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "无人机检测模块请求类")
public class UAVDetectionReq extends BasePageQuery {

    @ApiModelProperty(value = "数据集(正射影像或者反演数据)")
    private String dataType;

    @ApiModelProperty(value = "起始时间")
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String startTime;

    @ApiModelProperty(value = "结束时间")
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String endTime;

    @ApiModelProperty(value = "流域名称")
    private String streamName;

    @ApiModelProperty("关键字")
    private String keyWords;

}
