package com.cuit.solarenergy.entity.vo.req;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-19  18:59
 * @Description: 编辑用户参数类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@ApiModel("编辑用户参数类")
public class UserUpdateVoReq{

    /**
     * 主键
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(name = "id",value = "id",required = true)
    private Long id;
    /**
     * 用户名
     */
    @ApiModelProperty(name = "用户名",value = "userName",required = true)
    private String userName;
    /**
     * 昵称
     */
    @ApiModelProperty(name = "昵称",value = "nickName")
    private String nickName;
    /**
     * 邮箱
     */
    @ApiModelProperty(name = "邮箱",value = "email")
    private String email;
    /**
     * 手机号
     */
    @ApiModelProperty(name = "手机号",value = "phonenumber")
    private String phonenumber;
    /**
     * 用户类型（0管理员，1普通用户）
     */
    private String userType;

}