package com.cuit.solarenergy.entity.vo.ret;


import com.cuit.solarenergy.entity.vo.req.DataManageUpdateVoReq;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-06  10:37
 * @Description: 数据管理模块查询接口返回类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "数据管理模块查询接口返回类")
public class DataManageGetVoRet {

    @ApiModelProperty(value = "采样站点名")
    private String siteId;

    @ApiModelProperty(value = "采样时间/录入时间")
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String createTime;

    @ApiModelProperty(value = "水质参数值", hidden = true)
    private String params;

    @ApiModelProperty(value = "对应字符串, ','隔开")
    private String ids;

    @ApiModelProperty(value = "数据返回水质参数值list")
    private List<DataManageUpdateVoReq> paramsList;


}
