package com.cuit.solarenergy.entity.vo.ret;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-15  14:37
 * @Description: 监测模块首页站点信息返回类
 * @Version: 1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "监测模块首页站点信息返回类")
public class MonitorSitesVo {

    @ApiModelProperty("站点编号")
    private String siteId;

    @ApiModelProperty("指标值（-1：未检出）")
    private String indexValue;

    @ApiModelProperty("指标情况（0：正常，1：超标，2：严重超标）")
    private String indexLevel;

    @ApiModelProperty("经度")
    private String lon;

    @ApiModelProperty("纬度")
    private String lat;
}
