package com.cuit.solarenergy.entity.vo.ret;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;

import java.io.Serializable;
import java.util.Collections;
import java.util.List;

/**
 * 简分分页返回数据
 * @param <T>
 */
@Getter
@ApiModel(value = "分页对象", description = "分页数据查询")
public class PageVo<T> implements Serializable {
//    /**
//     * 查询数据列表
//     */
//    @ApiModelProperty("数据记录")
//    private String reordsType;
    /**
     * 查询数据列表
     */
    @ApiModelProperty("数据记录")
    private List<T> records = Collections.emptyList();
    /**
     * 总数
     */
    @ApiModelProperty("总条数")
    private long total = 0;
    /**
     * 每页显示条数
     */
    @ApiModelProperty("每页数量，<-1时为所有数据（即不分页）")
    private long size = -1;

    /**
     * 当前页
     */
    @ApiModelProperty("当前页码")
    private long currentpage = 1;

    @ApiModelProperty("总页数")
    private long pages = 1;

    @ApiModelProperty("是否有上页")
    private boolean hasPrevious = false;

    @ApiModelProperty("是否有下页")
    private boolean hasNext = false;

    public PageVo(Page<T> page) {
        if (page != null) {
            records = page.getRecords();
            total = page.getTotal();
            size = page.getSize();
            currentpage = page.getCurrent();
            pages = page.getPages();
            hasPrevious = page.hasPrevious();
            hasNext = page.hasNext();
        }
    }
}
