package com.cuit.solarenergy.entity.vo.ret;

import com.cuit.solarenergy.entity.vo.req.DataManageUpdateVoReq;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * @BelongsProject: railway
 * @BelongsPackage: com.cuit.solarenergy.entity.vo.ret
 * @Author: Luolw
 * @Date: 2023/8/5 15:18
 * @Description:
 */

@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "根据站点、水质参数获取曲线返回类")
public class StatisticQueryVoRet {
    @ApiModelProperty(value = "采样站点名")
    private String siteId;

    @ApiModelProperty(value = "采样时间/录入时间")
    @DateTimeFormat(pattern = DATE_FORMAT)
    private String createTime;

    @ApiModelProperty(value = "水质参数值", hidden = true)
    private String params;

    @ApiModelProperty(value = "数据返回水质参数值list")
    private List<DataManageUpdateVoReq> paramsList;


}
