package com.cuit.solarenergy.entity.vo.ret;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * 
 * @TableName ts_sys_user
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(value = "SysUserVoRet对象",description = "数据查询返回表")
public class SysUserVoRet implements Serializable {

    @TableId(value = "id", type = IdType.AUTO)
    @ApiModelProperty("用户id")
    private Integer id;

    @TableField(value = "loginname")
    @ApiModelProperty("登录名")
    private String loginname;

    @TableField(value = "name")
    @ApiModelProperty("姓名")
    private String name;

    @TableField(value = "tel")
    @ApiModelProperty("电话号码")
    private String tel;


    @TableField(value = "lastlogindate")
    @JsonFormat(pattern = DATE_FORMAT)
    @ApiModelProperty("最后一次登录时间")
    private Date lastlogindate;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}