package com.cuit.solarenergy.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cuit.solarenergy.entity.Role;
import com.cuit.solarenergy.entity.vo.ret.RoleManageVoRet;
import com.cuit.solarenergy.entity.vo.ret.UserManageVoRet;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
* @author PYJ
* @description 针对表【sys_role(角色表)】的数据库操作Mapper
* @createDate 2023-07-17 10:20:33
* @Entity com.cuit.solarenergy.entity.Role
*/
@Mapper
public interface RoleMapper extends BaseMapper<Role> {

    /**
     *
     * 获取系统管理-角色管理list
     */
    List<RoleManageVoRet> getRoleManageList();

    /**
     *
     * 获取系统管理-用户管理list
     */
    Page<UserManageVoRet> getUserManageList(Page page);

    /**
     *
     * 获取系统管理-用户管理关键字查询list
     */
    Page<UserManageVoRet> getUserManageListBySearch(Page page, String keyWord);
}




