package com.cuit.solarenergy.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cuit.solarenergy.common.dto.SysLogDto;
import com.cuit.solarenergy.entity.sys.SysLog;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.time.LocalDateTime;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author hpj
 * @since 2022-09-26
 */
@Mapper
@Repository
public interface SysLogMapper extends BaseMapper<SysLog> {


    /**
     * 多条件分页查询系统日志
     * @param page
     * @param stTime
     * @param endTime
     * @param userName
     * @param ip
     * @param module
     * @param opType
     * @return
     */
    Page<SysLogDto> querySysLogByQuery(Page page, LocalDateTime stTime, LocalDateTime endTime, String userName, String ip, String module, Integer opType);

}
