package com.cuit.solarenergy.model.poi.listener.head;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import lombok.*;

/**
 * 数据管理导入类
 *
 * @author tjb
 * @data 2023-07-10 11:01
*/
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode
@ToString
@HeadRowHeight(40)
public class DataManageExcelModel {

    @ExcelProperty( value= "采样点")
//    @ExcelProperty(index = 0)
    private String siteID;

    @ExcelProperty( value= "采样时间")
//    @ExcelProperty(index = 1)
    private String time;

    @ExcelProperty( value= "录入时间")
//    @ExcelProperty(index = 2)
    private String createTime;

    @ExcelProperty( value= "化学需氧量(COD)")
//    @ExcelProperty( value= "化学需氧量")
//    @ExcelProperty(index = 3)
    private Double COD;

    @ExcelProperty( value= "叶绿素(CPC)")
//    @ExcelProperty( value= "叶绿素")
//    @ExcelProperty(index = 4)
    private Double CPC;

    @ExcelProperty( value= "氟(F)")
//    @ExcelProperty( value= "氟")
//    @ExcelProperty(index = 5)
    private Double f;

    @ExcelProperty( value= "氨氮(NH3-N)")
//    @ExcelProperty( value= "氨氮")
//    @ExcelProperty(index = 6)
    private Double NH3N;

    @ExcelProperty( value= "营养状态(NTS)")
//    @ExcelProperty( value= "营养状态")
//    @ExcelProperty(index = 7)
    private Double NTS;

    @ExcelProperty( value= "石油类(OIL)")
//    @ExcelProperty( value= "石油类")
//    @ExcelProperty(index = 8)
    private Double OIL;

    @ExcelProperty( value= "氢离子浓度(PH)")
//    @ExcelProperty( value= "氢离子浓度")
//    @ExcelProperty(index = 9)
    private Double PH;

    @ExcelProperty( value= "硫酸根离子(SO42-)")
//    @ExcelProperty( value= "硫酸根离子")
//    @ExcelProperty(index = 10)
    private Double SO42;

    @ExcelProperty( value= "悬浮物(SPM)")
//    @ExcelProperty( value= "悬浮物")
//    @ExcelProperty(index = 11)
    private Double SPM;

    @ExcelProperty( value= "浊度(TBD)")
//    @ExcelProperty( value= "浊度")
//    @ExcelProperty(index = 12)
    private Double TBD;

    @ExcelProperty( value= "总氮(TNG)")
//    @ExcelProperty( value= "总氮")
//    @ExcelProperty(index = 13)
    private Double TNG;

    @ExcelProperty( value= "总磷(TP)")
//    @ExcelProperty( value= "总磷")
//    @ExcelProperty(index = 14)
    private Double TP;

    @ExcelProperty( value= "透明度(TSP)")
//    @ExcelProperty( value= "透明度")
//    @ExcelProperty(index = 15)
    private Double TSP;


}
