package com.cuit.solarenergy.service;

import com.cuit.solarenergy.entity.vo.ret.Stream;
import com.cuit.solarenergy.vo.TDataOriginMethod;

import java.util.List;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-03  14:18
 * @Description: TODO
 * @Version: 1.0
 */

public interface CommonService {

    /**
     *
     *  获取所有流域名称
     */
    List<Stream> getAllStreamName();
    /**
     *
     *  获取所有反演数据(水质参数)
     */
    List<String> getAllWaterQualityParameters();
    /**
     *
     *  获取所有流域名称
     */
    List<String> getOriginalDataSet();
    /**
     *
     *  获取原始影像数据集的集合
     */
    List<TDataOriginMethod> getAllDataOriginal();
    /**
     *
     *  通过缩略图查询真实图片URL
     */
    String getRealPictureForOne(String simplePicture);
    /**
     *
     *  通过缩略图查询真实视频URL
     */
    String getRealVideoForOne(String simpleVideo);
    /**
     *
     *  获取某一流域下所有的站点名称
     */
    List<String> getStationsForOneStream(String streamName);
    /**
     *
     *  获取某个站点所属流域名称
     */
    String getStationForOneSite(String siteId);
    /**
     *
     *  通过缩略图查询真实无人机URL
     */
    String getRealUAVForOne(String simpleUAV);

    /**
     *
     * 获取卫星列表
     */
    List<Object> getSatelliteList();

    /**
     *
     * 获取流域bbox
     */
    List<String> getStreamBbox(List<String> streamCodes);


    /**
     * 获取所有流域代码
     */
    List<String> getAllStreamCode();

    /**
     * 获取站点相对位置列表
     */
    List<String> getAllSiteLocation();

    /**
     * 获取站点相对距离列表
     */
    List<Double> getAllSiteDistance();
}