package com.cuit.solarenergy.service;

import com.cuit.solarenergy.base.BasePageQuery;
import com.cuit.solarenergy.entity.User;
import com.cuit.solarenergy.entity.vo.req.SystemManageModelVoReq;
import com.cuit.solarenergy.entity.vo.req.UserUpdateVoReq;
import com.cuit.solarenergy.entity.vo.ret.PageVo;
import com.cuit.solarenergy.entity.vo.ret.RoleManageVoRet;
import com.cuit.solarenergy.entity.vo.ret.UserManageVoRet;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-17  10:23
 * @Description: TODO
 * @Version: 1.0
 */
public interface SystemManageService {
    /**
     *
     * 获取系统管理-角色管理list
     */
    List<RoleManageVoRet> getRoleManageList();

    /**
     *
     * 获取系统管理-用户管理list
     */
    PageVo<UserManageVoRet> getUserManageList(BasePageQuery query);

    /**
     *
     * 系统管理-用户管理-更新用户信息
     */
    Boolean updateUser(UserUpdateVoReq userUpdateVoReq);

    /**
     *
     * 系统管理-用户管理-删除用户信息
     */
    Boolean deleteUser(String id);


    /**
     *
     * 系统管理-用户管理-修改密码Change password
     */
    Boolean changeUserPassword(Long id, String oldPassword, String newPassword);

    /**
     *
     * 系统管理-用户管理-修改密码Change password
     */
    Boolean changeUserPassword(String name, String oldPassword, String newPassword);


    /**
     *
     * 系统管理-用户管理-新增用户
     */
    Boolean addUser(User user);

    /**
     *
     * 获取系统管理-用户管理关键字查询list
     */
    PageVo<UserManageVoRet> getUserManageListBySearch(BasePageQuery query, String keyWord);

    /**
     *
     * 获取用户角色list
     */
    ArrayList<String> getUserRole();

    /**
     *
     * 保存模型参数
     */
    Boolean saveModel(SystemManageModelVoReq systemManageModelVoReq);

    /**
     * 密码复杂度检查，8个或以上字符，并且要求至少包含一个小写字母，一个大写字母，一个数字和一个特殊字符
     * @param password 密码
     * @return true 满足要求
     */
    Boolean checkPasswordComplexity(String password);
}
