package com.cuit.solarenergy.service;


import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 处理tif文件，发布数据并写及minio和DB，会占用较大的内存空间
 */
@Service
public interface TifDataDealService {

    /**
     * 处理一个tif文件，发布数据并写及minio和DB
      * @return
     */
    int dealTif2GeoserverAndMinioAndDB(String pathFileName);

    /**
     * 批量处理一个目录中的tif文件，发布数据并写及minio和DB
     * @return
     */
    List<String> batchDealTif2GeoserverAndMinioAndDB(String[] path);


    /**
     * 删除已发布的数据
     * @return
     */
    int deleteTif2GeoserverAndMinioAndDB();
}
