package com.cuit.solarenergy.service.impl;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelReader;
import com.alibaba.excel.enums.CellExtraTypeEnum;
import com.alibaba.excel.exception.ExcelAnalysisException;
import com.alibaba.excel.read.metadata.ReadSheet;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.cuit.solarenergy.entity.TSamplingDataDetails;
import com.cuit.solarenergy.entity.TSiteBaseInfo;
import com.cuit.solarenergy.mapper.TSamplingDataDetailsMapper;
import com.cuit.solarenergy.mapper.TSiteBaseInfoMapper;
import com.cuit.solarenergy.model.poi.listener.ExcelUtil;
import com.cuit.solarenergy.model.poi.listener.ImportExcelListener;
import com.cuit.solarenergy.model.poi.listener.head.DataManageExcelModel;
import com.cuit.solarenergy.service.DataImportService;
import com.cuit.solarenergy.service.TifDataDealService;
import com.cuit.solarenergy.utils.AssertUtil;
import com.cuit.solarenergy.utils.FileZipUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Author: Tjb
 * @CreateTime: 2023-07-11  14:53
 * @Description: TODO
 * @Version: 1.0
 */
@Service
@Slf4j
public class DataImportServiceImpl implements DataImportService {

    @Autowired
    private TSiteBaseInfoMapper tSiteBaseInfoMapper;

    @Autowired
    private TSamplingDataDetailsMapper tSamplingDataDetailsMapper;

    @Autowired
    private TifDataDealService tifDataDealService;

    @Override
    public List<String> upLoadProjectLedgerBySingleFile(MultipartFile file) throws IOException {
        return null;
    }

    @Override
    public String upLoadProjectLedgerByFiles(File[] ledgerFiles) {
        return null;
    }



    /**
     * 导入Excel坐标点信息
     *
     * @param railwayExcelFile 坐标点Excel文件
     * @return List<String>
     */
    @Override
    public List<String> upLoadRailwayDataByExcel(MultipartFile railwayExcelFile) {
        ArrayList<String> retMsg = new ArrayList<>();
        try {
            List<DataManageExcelModel> dataManageExcelModels = new ArrayList<>();
            AssertUtil.isTrue(railwayExcelFile == null, "上传文件不能为空！");
            String fileName = railwayExcelFile.getOriginalFilename();
            AssertUtil.isTrue(!fileName.matches("^.+\\.(?i)(xls)$") &&
                    !fileName.matches("^.+\\.(?i)(xlsx)$"), "上传文件格式错误，请上传后缀为.xls或.xlsx的文件。");
            // 1、读取Excel文件
            Map map = readExcel(railwayExcelFile);
            dataManageExcelModels = (List<DataManageExcelModel>) map.get("list");
            List<TSamplingDataDetails> list = new ArrayList<>();
            //循环取出数据并封装为能插入数据库的类
            dataManageExcelModels.stream().forEach((DataManageExcelModel item) -> {
                //1.获取站点经纬度
                LambdaQueryWrapper<TSiteBaseInfo> tSiteBaseInfoLambdaQueryWrapper = new LambdaQueryWrapper<>();
                tSiteBaseInfoLambdaQueryWrapper.eq(TSiteBaseInfo::getStationNo, item.getSiteID());
                TSiteBaseInfo tSiteBaseInfo = tSiteBaseInfoMapper.selectOne(tSiteBaseInfoLambdaQueryWrapper);
                //2.逐一封装数据为list

                TSamplingDataDetails tSamplingDataDetailsForCOM = TSamplingDataDetails.builder()
                        .siteId(item.getSiteID())
                        .createTime(item.getCreateTime())
                        .lon(tSiteBaseInfo.getLon())
                        .lat(tSiteBaseInfo.getLat())
                        .build();
                //3.返回list
                ProcessIndex(list, tSamplingDataDetailsForCOM, item);
            });
            //将list插入数据库
            Integer integer = tSamplingDataDetailsMapper.insertByBatch(list);
            log.info("成功插入 {} 条数据",integer);

        } catch (IOException e) {
            throw new RuntimeException(e);
        }

        return retMsg;

    }

    private void ProcessIndex(List<TSamplingDataDetails> listForTemp, TSamplingDataDetails tSamplingDataDetailsForCOM, DataManageExcelModel item) {

        TSamplingDataDetails tSamplingDataDetailsForCOD = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForCPC = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForF = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForNH3N = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForNTS = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForOIL = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForPH = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForSO42 = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForSPM = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForTBD = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForTNG = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForTP = new TSamplingDataDetails();
        TSamplingDataDetails tSamplingDataDetailsForTSP = new TSamplingDataDetails();


        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForCOD);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForCPC);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForF);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForNH3N);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForNTS);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForOIL);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForPH);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForSO42);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForSPM);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForTBD);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForTNG);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForTP);
        BeanUtils.copyProperties(tSamplingDataDetailsForCOM, tSamplingDataDetailsForTSP);

        tSamplingDataDetailsForCOD.setIndexCode("COD");
        tSamplingDataDetailsForCPC.setIndexCode("CPC");
        tSamplingDataDetailsForF.setIndexCode("F");
        tSamplingDataDetailsForNH3N.setIndexCode("NH3N");
        tSamplingDataDetailsForNTS.setIndexCode("NTS");
        tSamplingDataDetailsForOIL.setIndexCode("OIL");
        tSamplingDataDetailsForPH.setIndexCode("PH");
        tSamplingDataDetailsForSO42.setIndexCode("SO42");
        tSamplingDataDetailsForSPM.setIndexCode("SPM");
        tSamplingDataDetailsForTBD.setIndexCode("TBD");
        tSamplingDataDetailsForTNG.setIndexCode("TNG");
        tSamplingDataDetailsForTP.setIndexCode("TP");
        tSamplingDataDetailsForTSP.setIndexCode("TSP");

        tSamplingDataDetailsForCOD.setIndexValue(item.getCOD());
        tSamplingDataDetailsForCPC.setIndexValue(item.getCPC());
        tSamplingDataDetailsForF.setIndexValue(item.getF());
        tSamplingDataDetailsForNH3N.setIndexValue(item.getNH3N());
        tSamplingDataDetailsForNTS.setIndexValue(item.getNTS());
        tSamplingDataDetailsForOIL.setIndexValue(item.getOIL());
        tSamplingDataDetailsForPH.setIndexValue(item.getPH());
        tSamplingDataDetailsForSO42.setIndexValue(item.getSO42());
        tSamplingDataDetailsForSPM.setIndexValue(item.getSPM());
        tSamplingDataDetailsForTBD.setIndexValue(item.getTBD());
        tSamplingDataDetailsForTNG.setIndexValue(item.getTNG());
        tSamplingDataDetailsForTP.setIndexValue(item.getTP());
        tSamplingDataDetailsForTSP.setIndexValue(item.getTSP());

        tSamplingDataDetailsForCOD.setIndexLevel(0);
        tSamplingDataDetailsForCPC.setIndexLevel(0);
        tSamplingDataDetailsForF.setIndexLevel(0);
        tSamplingDataDetailsForNH3N.setIndexLevel(0);
        tSamplingDataDetailsForNTS.setIndexLevel(0);
        tSamplingDataDetailsForOIL.setIndexLevel(0);
        tSamplingDataDetailsForPH.setIndexLevel(0);
        tSamplingDataDetailsForSO42.setIndexLevel(0);
        tSamplingDataDetailsForSPM.setIndexLevel(0);
        tSamplingDataDetailsForTBD.setIndexLevel(0);
        tSamplingDataDetailsForTNG.setIndexLevel(0);
        tSamplingDataDetailsForTP.setIndexLevel(0);
        tSamplingDataDetailsForTSP.setIndexLevel(0);

        listForTemp.add(tSamplingDataDetailsForCOD);
        listForTemp.add(tSamplingDataDetailsForCPC);
        listForTemp.add(tSamplingDataDetailsForF);
        listForTemp.add(tSamplingDataDetailsForNH3N);
        listForTemp.add(tSamplingDataDetailsForNTS);
        listForTemp.add(tSamplingDataDetailsForOIL);
        listForTemp.add(tSamplingDataDetailsForPH);
        listForTemp.add(tSamplingDataDetailsForSO42);
        listForTemp.add(tSamplingDataDetailsForSPM);
        listForTemp.add(tSamplingDataDetailsForTBD);
        listForTemp.add(tSamplingDataDetailsForTNG);
        listForTemp.add(tSamplingDataDetailsForTP);
        listForTemp.add(tSamplingDataDetailsForTSP);

    }

    @Override
    public void restoreSequence(Integer type) {

    }

    @Override
    public void export(HttpServletResponse response) {
        String fileName = "export-template";
        String sheetName = "0";

        try {
            ExcelUtil.writeExcel(response, null, fileName, sheetName, DataManageExcelModel.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public List<String> upLoadRailwayStaUAVTifData(MultipartFile[] railwayStaUAVTifDataFile){
        //设置时间格式
        SimpleDateFormat sdf = new SimpleDateFormat( "yyyyMMdd" );
        //1、处理文件位置
        //文件存放位置
        String realPath = "data";
        //按照时间格式划分
        String format = sdf.format(new Date());
        String path = realPath + File.separator+ format+ File.separator + UUID.randomUUID()+ File.separator;
//        String path = realPath + File.separator + UUID.randomUUID()+ File.separator;
//        String path = realPath;

        // 创建文件夹
        File folder = new File(path);
        if (!folder.exists()) {
            folder.mkdirs();
        }



        String objPath = System.getProperty("user.dir") + File.separator + path;
        // 2、保存文件到指定路径存文件到指定路径
        for (MultipartFile file : railwayStaUAVTifDataFile) {

            String fileName = file.getOriginalFilename();
            File dest = new File(System.getProperty("user.dir") + File.separator + path + fileName);
            try {
                file.transferTo(dest);

            } catch (IOException e) {
                log.error("上传保存文件时出错：" + e.getMessage());
            }
            if (fileName.toUpperCase().endsWith("ZIP")) {
                //压缩文件解压
                try {
                    FileZipUtil.unzip(dest, new File(objPath));
                } catch (IOException e) {
                    log.error("解压文件{}时出错：{}", fileName, e.getMessage());
                }
            }
        }

        String[] tifs = FileZipUtil.getFileNameList(objPath, "tif");


        List<String> retMsg = tifDataDealService.batchDealTif2GeoserverAndMinioAndDB(tifs);

        // 删除目录
        File dest = new File(System.getProperty("user.dir") + File.separator + path);
        deleteFolderRecursively(dest);
        return retMsg;













//        //设置时间格式
//        SimpleDateFormat sdf = new SimpleDateFormat( "yyyyMMdd" );
//        //1、处理文件位置
//        //文件存放位置
//        String realPath = "data";
//        //按照时间格式划分
////        String format = sdf.format(new Date());
////        String path = realPath + File.separator+ format+ File.separator + UUID.randomUUID()+ File.separator;
//        String path = realPath + File.separator + UUID.randomUUID()+ File.separator;
//
//        // 创建文件夹
//        File folder = new File(path);
//        if (!folder.exists()) {
//            folder.mkdirs();
//        }
//
//
//
//        String objPath = System.getProperty("user.dir") + File.separator + path;
//        // 2、保存文件到指定路径
//        for (MultipartFile file : railwayStaUAVTifDataFile) {
//
//            String fileName = file.getOriginalFilename();
//            File dest = new File(System.getProperty("user.dir") + File.separator + path + fileName);
//            try {
//                file.transferTo(dest);
//
//            } catch (IOException e) {
//                log.error("上传保存文件时出错：" + e.getMessage());
//            }
//            if (fileName.toUpperCase().endsWith("ZIP")) {
//                //压缩文件解压
//                try {
//                    FileZipUtil.unzip(dest, new File(objPath));
//                } catch (IOException e) {
//                    log.error("解压文件{}时出错：{}", fileName, e.getMessage());
//                }
//            }
//        }
//
//        String[] tifs = FileZipUtil.getFileNameList(objPath, "tif");
//
//
//        List<String> retMsg = tifDataDealService.batchDealTif2GeoserverAndMinioAndDB(tifs);
//
//        // 删除目录
//        File dest = new File(System.getProperty("user.dir") + File.separator + path);
//        deleteFolderRecursively(dest);
//        return retMsg;
    }


    /**
     * 递归删除文件夹及其内部所有文件
     * @param folder 要删除的文件夹
     * @return 是否删除成功
     */
    public static boolean deleteFolderRecursively(File folder) {
        if (folder.isDirectory()) {
            // 获取文件夹下的所有文件和子文件夹
            File[] files = folder.listFiles();
            if (files != null) {
                // 遍历并递归删除每个文件或子文件夹
                for (File file : files) {
                    if (!deleteFolderRecursively(file)) {
                        return false;
                    }
                }
            }
        }
        // 删除当前文件或空文件夹
        return folder.delete();
    }

    @Override
    public String deleteGeoserverStaUAVTifData() {
        int num = tifDataDealService.deleteTif2GeoserverAndMinioAndDB();
        return "已删除" + num + "个";
    }



    /**
     * 读取Excel文件
     *
     * @param coordsExcelFile Excel文件
     * @return List<DataManageExcelModel>
     */
    private List<DataManageExcelModel> readExcelSheets(MultipartFile coordsExcelFile) {

        List<DataManageExcelModel> list = new ArrayList<>();
        // 坐标数据读入
        try (InputStream fis = coordsExcelFile.getInputStream()) {
            // 一个文件一个reader
            ExcelReader excelReader = EasyExcel.read(fis).extraRead(CellExtraTypeEnum.MERGE).build();
            List<ReadSheet> sheetList = excelReader.excelExecutor().sheetList();
            log.info("开始读取坐标点Excel数据.....");
            if (!sheetList.isEmpty()) {
                sheetList.forEach(eachSheet -> {
                    ImportExcelListener<DataManageExcelModel> importExcelListener = new ImportExcelListener<>(2);
                    ReadSheet sheet = EasyExcel.readSheet(eachSheet.getSheetNo())
                            .head(DataManageExcelModel.class)
                            .registerReadListener(importExcelListener)
                            .headRowNumber(2)
                            .build();
                    log.info("开始读取sheet[{}]坐标点Excel数据.....", eachSheet.getSheetName());
                    excelReader.read(sheet);
                    List<DataManageExcelModel> data = importExcelListener.getList();
                    log.info("*************************************************************************");
                    log.info("sheet[{}] 读取到{}行数据...", eachSheet.getSheetName(), data.size());
                    log.info(String.valueOf(data));
                    list.addAll(data);
                });
            }
            excelReader.finish();
            log.info("坐标点Excel数据读取完成！");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return list;
    }


    public Map readExcel(MultipartFile file) throws IOException {
        Map map = new HashMap<>();
//    public List<DataManageExcelModel> readExcel() throws IOException {
        //读取Excel中的数据
//		File file = ResourceUtils.getFile("classpath:" + File.separator + "excel" + File.separator + "2014年-2021年一亿棵梭梭项目台账(全).xlsx");
        ExcelReader excelReader1 = EasyExcel.read(file.getInputStream()).extraRead(CellExtraTypeEnum.MERGE).build();
        List<ReadSheet> sheetList = excelReader1.excelExecutor().sheetList();
        List<DataManageExcelModel> list = new ArrayList<>();
        LinkedHashSet<DataManageExcelModel> DataManageExcelModels = new LinkedHashSet<>();
        List<String> messageList = new ArrayList<String>();

        if (!sheetList.isEmpty()) {
            try {
                for (ReadSheet eachSheet : sheetList) {
                    log.info("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++正在解析{}的台账表", eachSheet.getSheetName());
                    ImportExcelListener<DataManageExcelModel> importExcelListener = new ImportExcelListener<>(1);
                    ReadSheet sheet = EasyExcel.readSheet(eachSheet.getSheetNo()).head(DataManageExcelModel.class).registerReadListener(importExcelListener)
                            .headRowNumber(1).build();
                    excelReader1.read(sheet);
                    DataManageExcelModels.addAll(importExcelListener.getList());
                }
            } catch (ExcelAnalysisException e) {
                StringTokenizer st = new StringTokenizer(e.getMessage(), "|");
                while (st.hasMoreElements()) {
                    messageList.add(st.nextElement().toString());
                }
            }
        }
        excelReader1.finish();
        list = new ArrayList<>(DataManageExcelModels);
        System.out.println(list);
        map.put("msg", messageList);
        map.put("list", list);
        return map;
    }


}
