package com.cuit.solarenergy.service.impl;

import com.cuit.solarenergy.mapper.SysOtherMapper;
import com.cuit.solarenergy.service.SequenceService;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * GeoServer发布文件的ID序列实现
 * @author cuitg -- ZengwuWang
 * @date 2023年04月15日 0:26
 */
@Service
@Qualifier("GeoServerIDSequence")
public class SequenceServiceGeoServerIDImpl implements SequenceService {
    @Resource
    SysOtherMapper sysOtherMapper;

    private final String typeName = "geoserverpubid";

    @Override
    public void setTypeName(String typeName) {

    }

    @Override
    public Long getCurrval() {
        return sysOtherMapper.getCurrval(typeName);
    }

    @Override
    public Long getNextval() {
        return sysOtherMapper.getNextval(typeName);
    }

    @Override
    public Long getPreval() {
        return sysOtherMapper.getPreval(typeName);
    }
}
