package com.cuit.solarenergy.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cuit.solarenergy.entity.TStreamBaseInfo;
import com.cuit.solarenergy.entity.vo.req.StreamListGetVoReq;
import com.cuit.solarenergy.entity.vo.ret.PageVo;
import com.cuit.solarenergy.mapper.TStreamBaseInfoMapper;
import com.cuit.solarenergy.service.TStreamBaseInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
* @author PYJ
* @description 针对表【t_stream_base_info(河流基本信息表)】的数据库操作Service实现
* @createDate 2023-06-08 11:37:12
*/
@Service
public class TStreamBaseInfoServiceImpl implements TStreamBaseInfoService{

    @Autowired
    private TStreamBaseInfoMapper tStreamBaseInfoMapper;

    @Override
    public PageVo<TStreamBaseInfo> getList(StreamListGetVoReq req) {
        Page<TStreamBaseInfo> page = new Page<>(req.getCurrent(), req.getSize());
        page = tStreamBaseInfoMapper.getList(page, req.getStreamCode(), req.getKeywords());
        return new PageVo<>(page);

    }
}




