package com.cuit.solarenergy.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

import static com.cuit.solarenergy.utils.DateUtil.DATE_FORMAT;

/**
 * @Author: Tjb
 * @CreateTime: 2023-06-19  16:29
 * @Description: TODO
 * @Version: 1.0
 */
@NoArgsConstructor
@AllArgsConstructor
@Data
@ApiModel(value = "SitesInfosForOne", description = "采样点详情返回类")
@Builder
public class SitesInfosForOne implements Serializable {

    @ApiModelProperty("站点id")
    private String siteId;

    @ApiModelProperty("指标值")
    private Double indexValue;

    @ApiModelProperty("创建时间")
    @JsonFormat(pattern = DATE_FORMAT)
    private Date createTime;

}
